]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script
Don't show storage summary in trial mode
[backup-script.git] / bin / backup-script
index d1164a0e0564e0910ac7f7499f2697126c89a6a3..9d8576d1b34fd636e2509a71bd766a73ef3a5590 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/bash
 #
 # backup-script system for cloning systems using rsync
-# Copyright (c)2008-2011 Alexander Barton, alex@barton.de
+# Copyright (c)2008-2013 Alexander Barton, alex@barton.de
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 
 NAME=`basename $0`
 CONF_D="/etc/backup-script.d"
-VERBOSE=0
 PIDFILE="/var/run/$NAME.pid"
 
+DRYRUN=0
+VERBOSE=0
+
 export LC_ALL=C
 
 declare -i count_all=0
@@ -23,30 +25,28 @@ declare -i count_ok=0
 declare -i count_ok_vanished=0
 
 destinations=""
+
+# Default settings, can be overwritten in backup-script.conf:
 pre_exec=""
 post_exec=""
-
-if [ "$1" == "-p" ]; then
-       VERBOSE=1
-       shift
-fi
-
-if [ $# -gt 1 ]; then
-       echo "Usage: $NAME [-p] [<system>]"
+default_target=""
+default_user="root"
+default_ssh_args_add=""
+default_rsync_args_add=""
+default_exclude_args_add=""
+default_compress=1
+default_ping=1
+default_local=0
+
+Usage() {
+       echo "Usage: $NAME [<options>] [<system> [<system> [...]]]"
+       echo
+       echo "  -p, --progress    Show progress, see rsync(1)."
+       echo "  -d, --dry-run     Test run only, don't copy any data."
+       echo
+       echo "When no <system> is given, all defined systems are used."
+       echo
        exit 1
-fi
-
-Log() {
-       logger -t "$NAME" "$*"
-}
-
-Message() {
-       echo "$*"
-}
-
-MessageLog() {
-       Log "$*"
-       Message "$*"
 }
 
 CleanUp() {
@@ -71,20 +71,36 @@ GotSignal() {
        exit 9
 }
 
+while [ $# -gt 0 ]; do
+       case "$1" in
+         "-n"|"--dry-run")
+               DRYRUN=1; shift
+               ;;
+         "-p"|"--progress")
+               VERBOSE=1; shift
+               ;;
+         "-"*)
+               Usage
+               ;;
+         *)
+               break
+       esac
+done
+
 if [ $# -ge 1 ]; then
-       sys=${CONF_D}/$1
-       if [ ! -r "$sys" ]; then
-               echo "$NAME: Can' read \"$sys\"!"
-               exit 1
-       fi
+       for s in $@; do
+               if [ ! -r "${CONF_D}/$s" ]; then
+                       echo "$NAME: Can' read \"${CONF_D}/$s\"!"
+                       exit 1
+               fi
+               sys="$sys ${CONF_D}/$s"
+       done
 else
        sys=${CONF_D}/*
 fi
 
 trap GotSignal SIGINT
 
-Log "Started ..."
-
 echo -n "Started: "; date
 echo
 
@@ -92,7 +108,6 @@ echo
 
 # check and create PID file
 if [ -e "$PIDFILE" ]; then
-       Log "Lockfile \"$PIDFILE\" already exists. Aborting!"
        echo "Lockfile \"$PIDFILE\" already exists."
        echo "Is an other instance still running?"
        echo
@@ -125,51 +140,58 @@ for f in $sys; do
        [ -r "$f" -a -f "$f" ] || continue
 
        system=`basename $f`
-       user="root"
-       target=""
-       ssh_args_add=""
-       rsync_args_add=""
-       compress=1
-       ping=1
-       local=0
-
        case "$system" in
                "backup-script.conf"|*.sh)
                        continue
                        ;;
        esac
 
-       # Read in configuration file
+       # Set global defaults
+       user="$default_user"
+       target="$default_target"
+       ssh_args_add="$default_ssh_args_add"
+       rsync_args_add="$default_rsync_args_add"
+       exclude_args_add="$default_exclude_args_add"
+       compress="$default_compress"
+       ping="$default_ping"
+       local="$default_local"
+
+       # Read in system configuration file
        source "$f"
 
        [ "$local" -eq 0 ] \
-               && MessageLog "Working on \"$system\" ..." \
-               || MessageLog "Working on \"$system\" (local system) ..."
+               && echo "Working on \"$system\" ..." \
+               || echo "Working on \"$system\" (local system) ..."
 
        count_all=$count_all+1
 
        # Check target directory
        if [ -z "$target" ]; then
-               MessageLog "No target directory specified for \"$system\"!? Skipped."
+               echo "No target directory specified for \"$system\"!? Skipped!"
                echo; continue
        fi
        if [ ! -d "$target" ]; then
-               MessageLog "Target \"$target\" is not a directory!? \"$system\" skipped."
+               echo "Target \"$target\" is not a directory!? \"$system\" skipped!"
                echo; continue
        fi
 
-       destdir="$target"
-       target="$target/$system"
-       mkdir -p "$target"
+       sys_target="$target/$system"
+       if [ "$DRYRUN" -eq 0 ]; then
+               mkdir -p "$sys_target" >/dev/null 2>&1
+               if [ $? -ne 0 ]; then
+                       echo "Can't create \"$sys_target\"!? \"$system\" skipped!"
+                       echo continue
+               fi
+       fi
 
        if [ "$local" -eq 0 -a "$ping" -ne 0 ]; then
                # Check if system is alive
                ping -c 1 "$system" >/dev/null 2>&1
                if [ $? -ne 0 ]; then
-                       MessageLog "Host \"$system\" seems not to be alive!? Skipped."
+                       echo "Host \"$system\" seems not to be alive!? Skipped."
                        echo; continue
                fi
-               Message "OK, host \"$system\" seems to be alive."
+               echo "OK, host \"$system\" seems to be alive."
        fi
 
        ssh_cmd="ssh"
@@ -179,27 +201,32 @@ for f in $sys; do
        [ "$compress" -ne 0 ] && cmd="$cmd --compress"
        cmd="$cmd --rsh=\"$ssh_cmd\" --delete --delete-excluded --sparse"
        [ "$VERBOSE" -gt 0 ] && cmd="$cmd --progress"
-       cmd="$cmd --exclude=/BACKUP --exclude=/backup --exclude=/mnt"
        cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
-       cmd="$cmd --exclude=/usr/src --exclude=/usr/local/src"
-       cmd="$cmd --exclude=/var/cache/apt --exclude=/var/amavis/blocked"
-       cmd="$cmd --exclude=/var/log --exclude=/tmp --exclude=/var/tmp"
+       cmd="$cmd --exclude=/run --exclude=/tmp --exclude=/var/tmp"
+       cmd="$cmd --exclude=/media --exclude=/mnt --exclude=/net"
+       cmd="$cmd --exclude=/var/cache/apt --exclude=/var/log"
+       [ -n "$exclude_args_add" ] && cmd="$cmd $exclude_args_add"
        [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
 
        [ "$local" -eq 0 ] \
-               && cmd="$cmd ${user}@${system}:/ $target" \
-               || cmd="$cmd / $target"
+               && cmd="$cmd ${user}@${system}:/ $sys_target/" \
+               || cmd="$cmd / $sys_target/"
 
-       Message "Calling: $cmd"
+       echo "Calling: $cmd"
        echo -n "Start date: "; date
        count_started=$count_started+1
-       rm -f "$target/.stamp"
+       rm -f "$sys_target/.stamp"
        
-       $SHELL -c "$cmd"; ret=$?
-       echo "code=$ret" >"$target/.stamp"
+       if [ "$DRYRUN" -eq 0 ]; then
+               $SHELL -c "$cmd"; ret=$?
+               echo "code=$ret" >"$sys_target/.stamp"
+       else
+               echo " *** Trial run, not executing synchronization command!"
+               ret=0
+       fi
 
        if [ $ret -eq 20 ]; then
-               MessageLog "Backup of \"$system\" interrupted. Aborting ..."
+               echo "Backup of \"$system\" interrupted. Aborting ..."
                CleanUp
                exit 1
        fi
@@ -207,23 +234,21 @@ for f in $sys; do
        if [ $ret -eq 0 -o $ret -eq 24 ]; then
                [ $ret -eq 24 ] && count_ok_vanished=$count_ok_vanished+1
 
-               MessageLog "System \"$system\" completed with status $ret, OK."
-               count_ok=$count_ok+1
+               echo "System \"$system\" completed with status $ret, OK."
+               [ "$DRYRUN" -gt 0 ] || count_ok=$count_ok+1
        else
-               MessageLog "System \"$system\" completed with ERRORS, code $ret!"
+               echo "System \"$system\" completed with ERRORS, code $ret!"
        fi
        echo -n "End date: "; date
 
-       destinations="$destinations $destdir"
+       destinations="$destinations $target"
        echo
 done
 
 sync
 
-Log "Done: $count_all jobs, $count_started started, $count_ok completed without errors."
-
 paths=$( echo $destinations | sed -e 's/ /\n/g' | sort | uniq )
-if [ -n "$paths" ]; then
+if [ "$DRYRUN" -eq 0 -a -n "$paths" ]; then
        df -h $paths
        echo
 fi